<?php
/*
Plugin Name: Hidden Affiliate Links 
Plugin URI: http://patchlog.com/wordpress/hidden-affiliate-links-update-v0.2/
Description: Hides affiliate links by wrapping them into a page that will redirect to the actual link
Author: Mihai Secasiu
Version: 0.2
Licence: GPL
Author URI: http://patchlog.com/
*/


$hal_TableName = $wpdb->prefix . "hal_links";


$hal_version=0.1;

$hal_path="hidden-affiliate-links-$hal_version"; // no trailing slash 


/**
 * Hook the admin menu action to call the hal_admin_option function
 *
 */
add_action('admin_menu', 'hal_admin_option');


/**
 * Adds the hidden affiliate links option to the administration menu
 *
 */
function hal_admin_option() {
    global $wpdb;
    if (function_exists('add_submenu_page'))
        add_submenu_page('edit.php', __('Hidden Affiliate Links'), __('Hidden Affiliate Links'), 1, __FILE__, 'hal_admin_panel');
}


/**
 * Hook the activate option to create the SQL table
 *
 */
add_action('activate_'.$hal_path.'/hidden-affiliate-links.php','hal_install');


/**
 * Run install function if not installed
 *
 */
if (!(get_option('hal_installed') == 'true')) hal_install();


/**
 * Runs installation procedures
 *
 */
function hal_install() {
	global $wpdb, $hal_TableName;

	// Make sure the table hasn't been created
	if($wpdb->get_var("SHOW tables LIKE '$hal_TableName'") != $hal_TableName) {
		update_option('hal_installed','false');

		// Build the query
		$sql = "CREATE TABLE ".$hal_TableName." (
						link_id mediumint(9) NOT NULL AUTO_INCREMENT,
						slug varchar(100) NOT NULL,
						keywords text not null,
						link text NOT NULL,
						new_link text NOT NULL,
						description text NOT NULL,
						PRIMARY KEY link_id (link_id)
					 );";

		require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
		dbDelta($sql);

		update_option('hal_installed','true');
	}
}

add_action('admin_print_scripts', 'hal_add_header_js');

function hal_add_header_js()
{
	global $hal_path;
	if(function_exists('wp_enqueue_script')){
		wp_enqueue_script( 'listman' );
		wp_enqueue_script('hal_list',get_bloginfo('wpurl') . '/wp-content/plugins/'.$hal_path.'/js/hal-list.js');
	}
}

add_action('wp_ajax_delete-ha_link','hal_delete_link');

function hal_delete_link()
{
	global $hal_TableName,$wpdb,$wp_rewrite;
	$link_id=$_POST['id'];
	$sql="delete from $hal_TableName where link_id=$link_id";
	if($wpdb->query($sql)){
        	$wp_rewrite->matches = 'matches';
        	$wp_rewrite->rewrite_rules();
	        update_option('rewrite_rules', $wp_rewrite->rules);
		die('1');
	}
}

add_action('wp_ajax_add-ha_link','hal_add_link');


function wp_ajax_ha_link_row($lid,$slug,$keyw,$newl,$link,$desc,$class='',$new='')
{
        $slug = attribute_escape($slug);
	$link = attribute_escape($link);
	$desc = attribute_escape($desc);
        $slug_js = addslashes(wp_specialchars($slug, 'double'));
	if($new!=""){
		$new=" onkeypress=\"return killSubmit('theList.ajaxUpdater(\\'ha_link\\',\\'ha_link-$lid\\');',event);\" ";
		$newb="   onclick=\"return theList.ajaxUpdater('ha_link','ha_link-$lid');\" ";
	}
        $r .= "<tr id='ha_link-$lid' class='$class'><th style='text-align: center;' scope='row'>$lid</th><td align='center'>";
        $r .= "<input name='hal_slug[$lid]' tabindex='6' type='text' size='20' value='$slug' $new/>";
        $r .= "</td><td align='center'><textarea name='hal_keyw[$lid]' tabindex='6' rows='2' cols='14'>$keyw</textarea></td>";
	$r .= "</td><td align='center'><textarea name='hal_newl[$lid]' tabindex='6' rows='2' cols='14'>$newl</textarea></td>";
        $r .= "</td><td align='center'><textarea name='hal_link[$lid]' tabindex='6' rows='2' cols='14'>$link</textarea></td>";
	$r .= "<td align='center'><textarea name='hal_desc[$lid]' tabindex='6' rows='2' cols='14'>$desc</textarea></td><td align='center'>";

        $r .= "<input name='updateha_link[$lid]' type='button' class='updateha_link' tabindex='6' value='".attribute_escape(__('Update'))."'  $newb/>";
        $r .= "<input name='deleteha_link[$lid]' type='submit' onclick=\"return deleteSomething( 'ha_link', $lid, '";
        $r .= js_escape(sprintf(__("You are about to delete the '%s' hidden link.\n'OK' to delete, 'Cancel' to stop."), $slug_js));
        $r .= "' );\" class='deleteha_link' tabindex='6' value='".attribute_escape(__('Delete'))."' /></td></tr>";
        return $r;
}

function hal_add_link()
{
	global $hal_TableName,$wpdb,$wp_rewrite;
	$sql="insert into $hal_TableName (slug,keywords,new_link,link,description)values ('${_POST['hal_slug']}','${_POST['hal_keyw']}','${_POST['hal_newl']}','${_POST['hal_link']}','${_POST['hal_desc']}')";
	if($wpdb->query($sql)){
		$lid=$wpdb->insert_id;
		$x = new WP_Ajax_Response( array(
                	'what' => 'ha_link',
	                'id' => $lid,
        	        'data' => wp_ajax_ha_link_row( $lid, stripslashes($_POST['hal_slug']),stripslashes($_POST['hal_keyw']),stripslashes($_POST['hal_newl']), stripslashes($_POST['hal_link']),stripslashes($_POST['hal_desc']),'','1' ),
                	'supplemental' => array()
	        ) );
        	$x->send();
	        $wp_rewrite->matches = 'matches';
	        $wp_rewrite->rewrite_rules();
        	update_option('rewrite_rules', $wp_rewrite->rules);
		die('1');	
	}
}

add_action('wp_ajax_update-ha_link','hal_update_link');

function hal_update_link()
{
	global $hal_TableName, $wpdb,$wp_rewrite;
	foreach($_POST['hal_slug'] as $lid=>$slug){
		break;
	}
	$sql="update $hal_TableName set slug='$slug', keywords='".$_POST['hal_keyw'][$lid]."', new_link='".$_POST['hal_newl'][$lid]."', link='".$_POST['hal_link'][$lid]."', description='".$_POST['hal_desc'][$lid]."' where link_id=$lid";
	if($wpdb->query($sql)){
		$wp_rewrite->matches = 'matches';
        	$wp_rewrite->rewrite_rules();
	        update_option('rewrite_rules', $wp_rewrite->rules);
		$x = new WP_Ajax_Response( array(
                	'what' => 'ha_link',
	                'id' => $lid,
        	        'data' => wp_ajax_ha_link_row( $lid, stripslashes($_POST['hal_slug'][$lid]), stripslashes($_POST['hal_keyw'][$lid]), stripslashes($_POST['hal_newl'][$lid]),stripslashes($_POST['hal_link'][$lid]),stripslashes($_POST['hal_desc'][$lid]),'','1'),
                	'supplemental' => array()
	        ) );
        	$x->send();
	}
	die('1');
}

/**
 * Builds the administration panel to configure the plugin and manage links
 *
 */
function hal_admin_panel() {
    global $hal_TableName,$wpdb;
    ?>

    <div class="wrap">
        <h2 id="write-post">Affiliate Links</h2>
	<form id="halink" onsubmit="return false;">
	<table >
		<thead>
		<tr>
			<th scope="col"><div style="text-align:center">ID</div></th>
			<th scope="col"><div style="text-align:center">Match Slug</div></th>
			<th scope="col"><div style="text-align:center">Replace Keywords</div></th>
			<th scope="col"><div style="text-align:center">New Link</div></th>
			<th scope="col"><div style="text-align:center">Redirect to Link/Code</div></th>
			<th scope="col"><div style="text-align:center">Description</div></th>
			<th scope="col"></th>
		</tr>
		<tr id="newha_link">
		<td></td>
		<td><input type="text" tabindex="7" name="hal_slug" id="hal_slug"/></td>
		<td><textarea tabindex="8" name="hal_keyw" id="hal_keyw" rows='2' cols='14'></textarea></td>
		<td><textarea tabindex="8" name="hal_newl" id="hal_newl" rows='2' cols='14'></textarea></td>
		<td><textarea tabindex="8" name="hal_link" id="hal_link" rows='2' cols='14'></textarea></td>
		<td><textarea tabindex="9" name="hal_desc" id="hal_desc" rows='2' cols='14'></textarea></td>
		<td><input type="submit" id="updatehalinksub" value="Add hidden Link" tabindex="10" name="updatehalink" /></td>
		</tr>
		</thead>
		<tbody id='the-list'>
		<?
		$sql="select * from $hal_TableName";
		$links=$wpdb->get_results($sql);
		if(is_array($links) && count($links)>0){
		$i=0;
		foreach($links as $link){
			if ($i % 2)
                        	$class = ' alternate';
			else $class='';
			echo wp_ajax_ha_link_row($link->link_id,$link->slug,$link->keywords,$link->new_link,$link->link,$link->description,$class);
			$i++;
		}
		}else{
			?>
			<tr style="display: none">
				<td> </td>
			</tr>
			<?
		}

		?>
		</tbody>
	</table>
	</form>
    </div>
    <div style="display:hidden" id="ajax-response"></div>
    <?            
}


function hal_rewrite_rules($rules)
{
        global $wp_rewrite,$wpdb,$hal_TableName;
	$sql="select slug,link_id from $hal_TableName";
	$hals=$wpdb->get_results($sql,ARRAY_A);
	$my_rules=Array();
	if(is_array($hals) && count($hals)>0){
		foreach($hals as $hal){
		        $my_rules[$hal['slug']]='index.php?action=hal_redirect&link_id='.urlencode($hal['link_id']);
		}
        	$rules=array_merge($my_rules,$rules);
	}
        return $rules;
}

$hal_query_vars=Array('action','link_id');

function hal_add_query_vars($query_vars)
{
        global $hal_query_vars;
        return array_merge($query_vars,$hal_query_vars);
}
function hal_parse_request($req)
{
        global $hal_query_vars,$wpdb,$hal_TableName,$hal_path;
        foreach($hal_query_vars as $qv){
                if(isset($req->query_vars[$qv])){
                        $_GET[$qv]=$req->query_vars[$qv];
                }
        }
	
	if($_GET['action']=='hal_redirect'){
		$sql="select * from $hal_TableName where link_id=".$_GET['link_id'];
		$hals=$wpdb->get_results($sql,ARRAY_A);
		if($hals){
		foreach($hals as $hal){
			if(preg_match('@^ *http://@s',$hal['link'])){
				include('wp-content/plugins/'.$hal_path.'/redirect_link.php');	
			}else{
				include('wp-content/plugins/'.$hal_path.'/redirect_code.php');
			}
			exit(0);
		}
		}
	}
}


function hal_init()
{
        global $wp_rewrite;
        if (isset($wp_rewrite) && $wp_rewrite->using_permalinks()) {
                add_filter('rewrite_rules_array', 'hal_rewrite_rules');
		add_filter('query_vars','hal_add_query_vars');
		add_action('parse_request','hal_parse_request');
        }
}
add_action('init','hal_init');


function hal_save_pre($content)
{
	global $wpdb,$hal_TableName;
	$r_sep='@';
	$sql="select keywords,slug,new_link from $hal_TableName";
	$reps=$wpdb->get_results($sql,ARRAY_A);
	if($reps && count($reps)>0){
		foreach($reps as $r){
			if($r['keywords'] != "" && $r['new_link'] != ""){
				$r['keywords']=preg_replace('/'.preg_quote($r_sep).'/','\\'.$r_sep,$r['keywords']);
				$content=preg_replace($r_sep.'([^a-zA-Z\-_]*)('.$r['keywords'].')([^a-zA-Z\-_]*)'.$r_sep,'$1<a href="'.$r['new_link'].'" title="'.$r['description'].'">$2</a>$3',$content);
			}

		}
	}
	return $content;
}

add_action('content_save_pre','hal_save_pre');



/**
 * Hook the DEactivate option to disable the plugin
 *
 */
add_action('deactivate_'.$hal_path.'/hidden-affiliate-links.php','hal_uninstall');


/**
 * Runs uninstallation
 *
 */
function hal_uninstall() {
	// Mark the plugin not installed
	update_option('hal_installed','false');
}

?>
